-- This file is loaded from "InterruptAwareness.toc"

local SPELL_LOCKOUTS =
{
-- [interruptSpellID] = lockoutDuration, -- Spell Name (Class)

[2139] = 6, -- Counterspell (Mage)
[115781] = 6, -- Optical Blast (Warlock)
[19647] = 6, -- Spell Lock (Warlock)
[173320] = 5, -- Spear Hand Strike (Monk)
[1766] = 5, -- Kick (Rogue)
[78675] = 5, -- Solar Beam (Druid)
[97547] = 5, -- Solar Beam Int (Druid)
[96231] = 4, -- Rebuke (Paladin)
[6552] = 4, -- Pummel (Warrior)
[47528] = 4, -- Mind Freeze (Death Knight)
[106839] = 4, -- Skull Bash (Druid)
[147362] = 3, -- Counter Shot (Hunter)
[187707] = 3, -- Muzzle (Hunter)
[57994] = 3, -- Wind Shear (Shaman)
[183752] = 3, -- Consume Magic (Demon Hunter)

}

-- If this is "DBM", DBM's timers will be used. If this is "SW", Blizzard's stopwatch will be used.
local MODE = "DBM"

-- The text to display on DBM Timers.
-- %SPELL% will be replaced with the name of the interrupt spell you cast.
-- %ISPELL% will be replaced with the name of the spell you interrupted
-- %DUR% will be replaced with the duration of the lockout.

local BARTEXT = "%SPELL% interrupted %ISPELL%. Locked out for %DUR% seconds"
-------------------
-- END OF CONFIG --
-------------------

local ARENA1_GUID;
local ARENA2_GUID;
local ARENA3_GUID;
local TARGET_GUID;
local PLAYER_GUID;

local ShowTimer; -- Declare the ShowTimer variable as local

if MODE == "DBM" and DBM then -- If MODE is "DBM" and there's a global variable DBM

local DBM = DBM -- Create a local alias to DBM
local gsubTable = {} -- This table is used to handle text substitutions with gsub

ShowTimer = function(seconds, interruptSpell, interruptedSpell) -- Define the ShowTimer function
gsubTable.SPELL = interruptSpell -- Populate the fields of the table
gsubTable.ISPELL = interruptedSpell
gsubTable.DUR = seconds
local text = BARTEXT:gsub("%%(%a+)%%", gsubTable) -- Replace each occurrence of %SPELL%, %ISPELL% or %DUR% with the corresponding field of gsubTable and assing the result to the text variable

DBM:CreatePizzaTimer(seconds, text) -- Create the timer
end

else -- Either MODE isn't "DBM", or there's no global variable DBM

ShowTimer = function(seconds)
Stopwatch_StartCountdown(0, 0, seconds)
Stopwatch_Play()
end

end

local spell_school_enum =
{
[1] = "Physical",
[2] = "Holy",
[4] = "Fire",
[8] = "Nature",
[12] = "Frost",
[32] = "Shadow",
[64] = "Arcane",

[3] = "HolyStrike",
[5] = "FlameStrike",
[6] = "HolyFire",
[9] = "StormStrike",

[124] = "Chaos", -- Chromatic
[127] = "Chaos",
}


local logframe = CreateFrame("Frame")
logframe:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
logframe:SetScript("OnEvent", function(self, event, ...)
--print(spell_school_enum[2])
local _,spell_event,_,_,Interrupter,_,_,_,Interrupted,_,_,spellId,Interrupt_Spell,_,_,Interrupted_Spell,school_Lockout = ...

if spell_event == "SPELL_INTERRUPT" then
--print(school_Lockout)
if friendly then
SendChatMessage(string.format("Ally: %s \\ Interrupted by: %s \\ Spell Cast: %s \\ Interrupted By: [%s\\%d] \\ School Lockout: %s",Interrupted,Interrupter,Interrupted_Spell,Interrupt_Spell,spellId,spell_school_enum[school_Lockout]),"PARTY")
else
SendChatMessage(string.format("Enemy: %s \\ Interrupted by: %s \\ Spell Cast: %s \\ Interrupted By: [%s\\%d] \\ School Lockout: %s",Interrupted,Interrupter,Interrupted_Spell,Interrupt_Spell,spellId,spell_school_enum[school_Lockout]),"PARTY")
end

local lockout = SPELL_LOCKOUTS[spellId] -- Check if we have a lockout time for this interrupt spell

if lockout then -- If we do, show a timer.
ShowTimer(lockout, Interrupted_Spell)
end
end

end)

local f = CreateFrame("Frame") -- Create a frame and register some events.
f:RegisterEvent("PLAYER_ENTERING_WORLD")
function f:PLAYER_ENTERING_WORLD() -- This fires towards the end of the intitial login process.
ARENA1_GUID = UnitGUID("arena1") -- Record the arena1 GUID
ARENA2_GUID = UnitGUID("arena2") -- Record the arena2 GUID
ARENA3_GUID = UnitGUID("arena3") -- Record the arena3 GUID
TARGET_GUID = UnitGUID("target") -- Record the Target's GUID
PLAYER_GUID = UnitGUID("player") -- Record the player's GUID
self:UnregisterEvent("PLAYER_ENTERING_WORLD") -- Unregister this event, we don't care about it any more.
end
